'''Cerebro单例模式，全局变量控制
运行过程动作控制: 收集用例、上报测试结果、发送飞书群消息
读取环境控制
'''


class Cerebro:
    __instance = None
    __slots__ = [
        '_is_collect_cases',  # 是否执行收集用例
        '_is_report_test_result',  # 是否执行上报测试结果
        '_is_send_feishu_msg',  # 是否执行发送飞书消息
        '_is_save_case_json_locally',  # 是否保存本地用例数据json
        '_test_environment',  # 测试环境
    ]

    def __new__(cls, *args, **kwargs):
        if not cls.__instance:
            cls.__instance = object.__new__(cls)
        return cls.__instance

    def __init__(self):
        self._is_collect_cases = False
        self._is_report_test_result = False
        self._is_send_feishu_msg = False
        self._is_save_case_json_locally = False
        self._test_environment = '生产'

    @property
    def test_environment(self):
        return self._test_environment

    @test_environment.setter
    def test_environment(self, env: str):
        self._test_environment = env

    @property
    def is_collect_cases(self):
        return self._is_collect_cases

    @is_collect_cases.setter
    def is_collect_cases(self, is_true: bool):
        self._is_collect_cases = is_true

    @property
    def is_report_test_result(self):
        return self._is_report_test_result

    @is_report_test_result.setter
    def is_report_test_result(self, is_true: bool):
        self._is_report_test_result = is_true

    @property
    def is_send_feishu_msg(self):
        return self._is_send_feishu_msg

    @is_send_feishu_msg.setter
    def is_send_feishu_msg(self, is_true: bool):
        self._is_send_feishu_msg = is_true

    @property
    def is_save_case_json_locally(self):
        return self._is_save_case_json_locally

    @is_save_case_json_locally.setter
    def is_save_case_json_locally(self, is_true: bool):
        self._is_save_case_json_locally = is_true

