'''
测试数据库
'''
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy import Column, String, Integer, Float, Boolean, DateTime
from sqlalchemy.dialects.mysql import LONGTEXT
import sqlalchemy_jsonfield
import datetime

Base = declarative_base()


class CaseCollection(Base):
    '''
    测试任务记录
    '''
    __tablename__ = "case_collection"
    id = Column(Integer, primary_key=True)  # 设置主键
    unique_code = Column(LONGTEXT)  # 用例唯一码
    case_name = Column(String(32))  # 用例名称
    first_node_doc = Column(LONGTEXT)  # 一级目录描述
    second_node_doc = Column(LONGTEXT)  # 二级目录描述
    first_node = Column(LONGTEXT)  # 一级目录路径
    second_node = Column(LONGTEXT)  # 二级目录路径
    modifyTime = Column(DateTime, default=datetime.datetime.now, comment='创建时间')


class TaskReport(Base):
    '''
    测试任务记录
    '''
    __tablename__ = "task_report"
    id = Column(Integer, primary_key=True)  # 设置主键
    task_id = Column(String(32))  # 任务执行uuid
    result = Column(sqlalchemy_jsonfield.JSONField(
        enforce_string=True,
        enforce_unicode=False
    ))
    modifyTime = Column(DateTime, default=datetime.datetime.now, comment='创建时间')


# 传入项目中的engine， 创建表
def new_tables(engine):
    Base.metadata.create_all(engine)
